-- test program to cover a bunch of interesting special cases for the
-- jtos implementation

module Main (main) where

import GHC.Base (ord)
import JtoSnew as N
import JtoSold as O

check :: Integer -> Bool
check n = N.jtos n "" == O.jtos n ""

checkPow10 :: Int -> Integer -> String -> Integer -> String -> Bool
checkPow10 0 _ _ _ _ = True
checkPow10 n p r o t = O.jtos p "" == r && checkPow10 (n-1) (10*p+o) (r++t) o t

count :: Int
count = 1024

main = do
    putStrLn $ "Small numbers:             success = " ++
        show (all check [-10000..10000])
    putStrLn $ "Special cases:             success = " ++
        show (all check [-2^64, -2^64+1, -2^32, -2^32+1, 0,
                          2^32-1, 2^32, 2^64-1, 2^64])
    putStrLn $ "powers of 10:              success = " ++
        show (checkPow10 count 1 "1" 0 "0")
    putStrLn $ "negative powers of 10:     success = " ++
        show (checkPow10 count (-1) "-1" 0 "0")
    putStrLn $ "powers of 10, -1:          success = " ++
        show (checkPow10 count 9 "9" 9 "9")
    putStrLn $ "negative powers of 10, +1: success = " ++
        show (checkPow10 count (-9) "-9" (-9) "9")
